clc
clear all
close all
 
modality=1;

if modality ==1,

meansp=63.625;
devstdsp=2.595;
Popolation=1000;

R = normrnd(meansp,devstdsp,Popolation,1);


Rmin=min(R);
Rmax=max(R);
Rmin=55.5;
Rmax=72.5;

classi=round(1+3.3*log10(Popolation));
classi=100;
x=[Rmin:(Rmax-Rmin)/(classi-1):Rmax];
% x=[Rmin:1:Rmax];
% classi=length(x);

[Occurrences,Xvalues]=hist(R,x);

else
    
Xvalues=[56.5 57.5 58.5 59.5 60.5 61.5 62.5 63.5 64.5 65.5 66.5 67.5 68.5 69.5 70.5 71.5]';
Occurrences=[ 2 18 23 31 83 109 138 151 139 130 82 49 28 11 4 2]';
classi=length(Occurrences);

lun=0;
Popolation=sum(Occurrences);
for i=1:length(Xvalues),
    R(lun+1:lun+Occurrences(i))=Xvalues(i)*ones(1,Occurrences(i));
    lun=length(R);
end

end

mu=mean(R);
dev=std(R);
Cov=dev/mu;

%__________________________________________________

%pdf sperimentale
sper_pdf=Occurrences./Popolation./mean(diff(Xvalues));
%__________________________________________________

%__________________________________________________

%cumulativa sperimantale
for i=1:length(sper_pdf)
    sper_cdf(i)=sum(sper_pdf(1:i))*mean(diff(Xvalues));
end
%__________________________________________________


[muhat1,varhat1] = normstat(mu,dev);
[muhat,sigmahat,muci,sigmaci] = normfit(R);
npdf=normpdf(Xvalues,muhat,sigmahat);
ncdf=normcdf(Xvalues,muhat,sigmahat);
%npdf=normpdf(Xvalues,muhat1,sqrt(varhat1));
%ncdf=normcdf(Xvalues,muhat1,sqrt(varhat1));

NXvalues=[min(Xvalues):(max(Xvalues)-min(Xvalues))/(classi*10-1):max(Xvalues)]';
Npdf=normpdf(NXvalues,muhat,sigmahat);
Ncdf=normcdf(NXvalues,muhat,sigmahat);

z=(NXvalues-mu)/dev;
x_sper=norminv(sper_cdf,muhat,sigmahat);
z_R=(x_sper-muhat)/sigmahat;

figure(100)
plot(NXvalues,z,'--r')
hold on
grid on
plot(Xvalues,z_R,'b','linewidth',2)
p = [0.001 0.003 0.01 0.02 0.05 0.10 0.25 0.5...
     0.75 0.90 0.95 0.98 0.99 0.997 0.999];
label1= str2mat('0.001','0.003', '0.01','0.02','0.05','0.10','0.25','0.50');
label2= str2mat('0.75','0.90','0.95','0.98','0.99','0.997', '0.999');
label = [label1;label2];
tick  = norminv(p,0,1);
set(gca,'YTick',tick,'YTickLabel',label);
axis([min(Xvalues)/1.05 max(Xvalues)*1.05 -4 4])

figure(1)
normplot(R)
grid on

figure(2)
hold on
hist(R,Xvalues)
% histfit(R,classi)
% plot(Xvalues,sper_pdf*Popolation*mean(diff(Xvalues)),'g','linewidth',2)
grid on
xlabel('x Data')
ylabel('Data Histogram')
title('Histogram')

figure(3)
hold on
plot(Xvalues,sper_pdf,'g','linewidth',1)
plot(Xvalues,npdf,'b','linewidth',1)
plot(NXvalues,Npdf,'r','linewidth',2)
grid on
xlabel('x Data')
ylabel('f(x) Probability density')
title('PDF and Normal Distribution')

figure(4)
plot(Xvalues,sper_cdf,'g','linewidth',1)
hold on
cdfplot(R)
plot(Xvalues,ncdf,'k','linewidth',1)
plot(NXvalues,Ncdf,'r','linewidth',2)
grid on
xlabel('x Data')
ylabel('F(x) Cumulative distribution function')
title('CDF and Normal Cumulative')

linf=60;
lsup=65;
SPEC=[linf lsup];
normspec(SPEC,muhat,sigmahat);
grid on
ylabel('f(x) Probability density')

pdf_inf=normpdf(linf,muhat,sigmahat)
pdf_sup=normpdf(lsup,muhat,sigmahat)
probability_inf=normcdf(linf,muhat,sigmahat)
probability_sup=normcdf(lsup,muhat,sigmahat)
probability=normcdf(lsup,muhat,sigmahat)-normcdf(linf,muhat,sigmahat)

Reliability=0.95
Probability=1-Reliability

x_R=norminv(Probability,muhat,sigmahat)
