close all
clear all
clc

Cs=0.3
CS=0.1;
mus=700;
devs=Cs*mus;
muS=1000;
devS=CS*muS;

Xvalues=[0:50:3000];

CS =  devS/muS;
Cs =  devs/mus;
Cn = sqrt((CS^2+Cs^2)/(1+Cs^2));

npdfS=normpdf(Xvalues,muS,devS);
npdfs=normpdf(Xvalues,mus,devs);
npdfz=normpdf(Xvalues,(muS-mus),(sqrt(devS^2+devs^2)));

for i=1:length(Xvalues),
    npdfsS(i,:)=npdfS(i)*npdfs;
end

nmed=muS/mus

% zn=-(muS-mus)/sqrt(devS^2+devs^2)
% Pn=normcdf(zn,0,1);
% Rn=1-Pn

[zn,Rn]=eqacc_norm(muS,devS,mus,devs)

% zln=-(log((muS/mus)*sqrt((1+Cs^2)/(1+CS^2)))/sqrt(log((1+CS^2)*(1+Cs^2))))
% Pln=normcdf(zln,0,1);
% Rln=1-Pln

[zln,Rln]=eqacc_logn(muS,CS,mus,Cs)

Rext=0.95;
Pext=1-Rext;
zext=norminv(Pext,0,1);

R=Rext;
z=zext;

if R>=0.5
    a=1;
else
    a=-1;
end

n=(1+(a)*sqrt(1-(1-z^2*CS^2)*(1-z^2*Cs^2)))/(1-z^2*CS^2)
nd=exp(Cn*(-z+Cn/2))

ProbabilityS=0.05;
Probabilitys=0.95;

Sk_P=norminv(ProbabilityS,muS,devS);
sk_P=norminv(Probabilitys,mus,devs);
S_p=normpdf(Sk_P,muS,devS);
s_p=normpdf(sk_P,mus,devs);

gammakS=muS/Sk_P;
gammaks=sk_P/mus;
CoeffSick=gammaks*gammakS;

gammaS=1.25;
gammas=1.5;
Sd=muS/gammaS;
sd=mus*gammas;
CoeffSicd=gammas*gammaS;

figid=0;

gamma=1;
[fxy,FXY,pM,PM,FM]=joint_distribution(mus,devs,muS,devS,Xvalues,gamma,figid);
PM
gamma=Sk_P/sk_P;
[fxy,FXY,pMk,PMk,FMk]=joint_distribution(mus,devs,muS,devS,Xvalues,gamma,figid);
PMk
gamma=Sd/sd;
[fxy,FXY,pMd,PMd,FMd]=joint_distribution(mus,devs,muS,devS,Xvalues,gamma,figid);
PMd

%%

figure(1)
surf(Xvalues,Xvalues,npdfsS)
hold on
xlabel('Sollecitazione (s) [stress units]')
ylabel('Resistenza (S) [stress units]')
zlabel('f(x) PDF')
title('Funzione di densit di Probabilit Congiunta')
plot3(Xvalues,ones(length(Xvalues),1)*0,npdfs*(max(max(npdfsS))/max(npdfs)),'k')
plot3(ones(length(Xvalues),1)*0,Xvalues,npdfS*(max(max(npdfsS))/max(npdfS)),'k')
plot3(diag(Xvalues),diag(Xvalues),ones(length(Xvalues),1)*0,'w','linewidth',2)

plot3(diag(Xvalues)*sd,diag(Xvalues)*Sd,ones(length(Xvalues),1)*0,'r','linewidth',2)
hold on
plot3(diag(Xvalues)*sk_P,diag(Xvalues)*Sk_P,ones(length(Xvalues),1)*0,'b','linewidth',2)
% plot3(0,S_P,S_p*(max(max(npdfsS))/max(npdfS)),'ro','linewidth',2)
% plot3(s_P,0,s_p*(max(max(npdfsS))/max(npdfs)),'bo','linewidth',2)
plot3(ones(length(Xvalues),1)*sk_P,Xvalues,ones(length(Xvalues),1)*0,'b','linewidth',1)
plot3(Xvalues,ones(length(Xvalues),1)*Sk_P,ones(length(Xvalues),1)*0,'b','linewidth',1)
plot3(ones(length(Xvalues),1)*sd,Xvalues,ones(length(Xvalues),1)*0,'r','linewidth',1)
plot3(Xvalues,ones(length(Xvalues),1)*Sd,ones(length(Xvalues),1)*0,'r','linewidth',1)
S=axis;
axis([Xvalues(1) Xvalues(end) Xvalues(1) Xvalues(end) S(5) S(6)])

%%

figure(2)
contour3(Xvalues,Xvalues,npdfsS,50)
hold on
xlabel('Sollecitazione (s) [stress units]')
ylabel('Resistenza (S) [stress units]')
zlabel('f(x) PDF')
title('Funzione di densit di Probabilit Congiunta')
plot3(Xvalues,ones(length(Xvalues),1)*0,npdfs*(max(max(npdfsS))/max(npdfs)),'k')
plot3(ones(length(Xvalues),1)*0,Xvalues,npdfS*(max(max(npdfsS))/max(npdfS)),'k')
plot3(diag(Xvalues),diag(Xvalues),ones(length(Xvalues),1)*0,'k','linewidth',2)

plot3(diag(Xvalues)*sd,diag(Xvalues)*Sd,ones(length(Xvalues),1)*0,'r','linewidth',2)
hold on
plot3(diag(Xvalues)*sk_P,diag(Xvalues)*Sk_P,ones(length(Xvalues),1)*0,'b','linewidth',2)
% plot3(0,S_P,S_p*(max(max(npdfsS))/max(npdfS)),'ro','linewidth',2)
% plot3(s_P,0,s_p*(max(max(npdfsS))/max(npdfs)),'bo','linewidth',2)
plot3(ones(length(Xvalues),1)*sk_P,Xvalues,ones(length(Xvalues),1)*0,'b','linewidth',1)
plot3(Xvalues,ones(length(Xvalues),1)*Sk_P,ones(length(Xvalues),1)*0,'b','linewidth',1)
plot3(ones(length(Xvalues),1)*sd,Xvalues,ones(length(Xvalues),1)*0,'r','linewidth',1)
plot3(Xvalues,ones(length(Xvalues),1)*Sd,ones(length(Xvalues),1)*0,'r','linewidth',1)
S=axis;
axis([Xvalues(1) Xvalues(end) Xvalues(1) Xvalues(end) S(5) S(6)])

%%

p=normspec([-inf 0],(muS-mus),(sqrt(devS^2+devs^2)));
hold on
plot(Xvalues,npdfS,'g','linewidth',2)
plot(Xvalues,npdfs,'r','linewidth',2)
plot(Xvalues,npdfz,'b','linewidth',2)
grid on
xlabel('Sollecitazione/Resistenza [stress units]')
ylabel('f(x) PDF')
str = ['Probability Between Limits is ',num2str(p)];
title(str)

%%

figure(4)
subplot(2,2,2); contour3(Xvalues,Xvalues,npdfsS,50) ;axis([Xvalues(1)  Xvalues(end) Xvalues(1)  Xvalues(end)]); h1 = gca;
title('Simulated Dependent Sigma and Strength Values');
xlabel('X1 ~ Sigma'); ylabel('X2 ~ Strength');
hold on
plot(Xvalues,Xvalues,'k','linewidth',2)
plot(diag(Xvalues)*sd,diag(Xvalues)*Sd,'r','linewidth',2)
plot(diag(Xvalues)*sk_P,diag(Xvalues)*Sk_P,'b','linewidth',2)
plot(ones(length(Xvalues),1)*sk_P,Xvalues,'b','linewidth',1)
plot(Xvalues,ones(length(Xvalues),1)*Sk_P,'b','linewidth',1)
plot(ones(length(Xvalues),1)*sd,Xvalues,'r','linewidth',1)
plot(Xvalues,ones(length(Xvalues),1)*Sd,'r','linewidth',1)
S=axis;
axis([Xvalues(1) Xvalues(end) Xvalues(1) Xvalues(end)])
subplot(2,2,4); plot(Xvalues,-npdfs); axis([Xvalues(1)  Xvalues(end) -max(npdfs)*1.1 0]); grid on; h2 = gca;
subplot(2,2,1); plot(-npdfS,Xvalues); axis([-max(npdfS)*1.1 0 Xvalues(1)  Xvalues(end)]); grid on; h3 = gca; 
set(h1,'Position',[0.35 0.35 0.55 0.55]);
set(h2,'Position',[.35 .1 .55 .15]);
set(h3,'Position',[.1 .35 .15 .55]);

%%

figure(5)
surf(Xvalues,Xvalues,pMk)
hold on
xlabel('Sollecitazione (s) [stress units]')
ylabel('Resistenza (S) [stress units]')
zlabel('f(x) PDF')
title('Funzione di densit di Probabilit Congiunta')
plot3(Xvalues,ones(length(Xvalues),1)*0,npdfs*(max(max(npdfsS))/max(npdfs)),'k')
plot3(ones(length(Xvalues),1)*0,Xvalues,npdfS*(max(max(npdfsS))/max(npdfS)),'k')
plot3(diag(Xvalues),diag(Xvalues),ones(length(Xvalues),1)*0,'k','linewidth',2)
plot3(diag(Xvalues)*sd,diag(Xvalues)*Sd,ones(length(Xvalues),1)*0,'r','linewidth',2)
hold on
plot3(diag(Xvalues)*sk_P,diag(Xvalues)*Sk_P,ones(length(Xvalues),1)*0,'b','linewidth',2)
% plot3(0,S_P,S_p*(max(max(npdfsS))/max(npdfS)),'ro','linewidth',2)
% plot3(s_P,0,s_p*(max(max(npdfsS))/max(npdfs)),'bo','linewidth',2)
plot3(ones(length(Xvalues),1)*sk_P,Xvalues,ones(length(Xvalues),1)*0,'b','linewidth',1)
plot3(Xvalues,ones(length(Xvalues),1)*Sk_P,ones(length(Xvalues),1)*0,'b','linewidth',1)
plot3(ones(length(Xvalues),1)*sd,Xvalues,ones(length(Xvalues),1)*0,'r','linewidth',1)
plot3(Xvalues,ones(length(Xvalues),1)*Sd,ones(length(Xvalues),1)*0,'r','linewidth',1)
S=axis;
axis([Xvalues(1) Xvalues(end) Xvalues(1) Xvalues(end) S(5) S(6)])

%%

figure(6)
subplot(2,2,2); contour3(Xvalues,Xvalues,pMd,50) ;axis([Xvalues(1)  Xvalues(end) Xvalues(1)  Xvalues(end)]); h1 = gca;
title('Simulated Dependent Sigma and Strength Values');
xlabel('X1 ~ Sigma'); ylabel('X2 ~ Strength');
hold on
plot(Xvalues,Xvalues,'k','linewidth',2)
plot(diag(Xvalues)*sd,diag(Xvalues)*Sd,'r','linewidth',2)
plot(diag(Xvalues)*sk_P,diag(Xvalues)*Sk_P,'b','linewidth',2)
plot(ones(length(Xvalues),1)*sk_P,Xvalues,'b','linewidth',1)
plot(Xvalues,ones(length(Xvalues),1)*Sk_P,'b','linewidth',1)
plot(ones(length(Xvalues),1)*sd,Xvalues,'r','linewidth',1)
plot(Xvalues,ones(length(Xvalues),1)*Sd,'r','linewidth',1)
S=axis;
axis([Xvalues(1) Xvalues(end) Xvalues(1) Xvalues(end)])
subplot(2,2,4); plot(Xvalues,-npdfs); axis([Xvalues(1)  Xvalues(end) -max(npdfs)*1.1 0]); grid on; h2 = gca;
subplot(2,2,1); plot(-npdfS,Xvalues); axis([-max(npdfS)*1.1 0 Xvalues(1)  Xvalues(end)]); grid on; h3 = gca; 
set(h1,'Position',[0.35 0.35 0.55 0.55]);
set(h2,'Position',[.35 .1 .55 .15]);
set(h3,'Position',[.1 .35 .15 .55]);

%%

figure(7)
subplot(2,2,2); contour3(Xvalues,Xvalues,pM,50) ;axis([Xvalues(1)  Xvalues(end) Xvalues(1)  Xvalues(end)]); h1 = gca;
title('Simulated Dependent Sigma and Strength Values');
xlabel('X1 ~ Sigma'); ylabel('X2 ~ Strength');
hold on
plot(Xvalues,Xvalues,'k','linewidth',2)
S=axis;
axis([Xvalues(1) Xvalues(end) Xvalues(1) Xvalues(end)])
subplot(2,2,4); plot(Xvalues,-npdfs); axis([Xvalues(1)  Xvalues(end) -max(npdfs)*1.1 0]); grid on; h2 = gca;
subplot(2,2,1); plot(-npdfS,Xvalues); axis([-max(npdfS)*1.1 0 Xvalues(1)  Xvalues(end)]); grid on; h3 = gca; 
set(h1,'Position',[0.35 0.35 0.55 0.55]);
set(h2,'Position',[.35 .1 .55 .15]);
set(h3,'Position',[.1 .35 .15 .55]);

%%


