close all
clear all

muS=10;
mus=3.75;
devS=1.5;
devs=1.25;
Xvalues=[0.0:0.1:30];

gammaS=1.1;
gammas=1.17;

[z,R]=eqacc_norm(muS,devS,mus,devs);
P=1-R

npdfS=normpdf(Xvalues,muS,devS);
npdfs=normpdf(Xvalues,mus,devs);
npdfz=normpdf(Xvalues,(muS-mus),(sqrt(devS^2+devs^2)));
p=normspec([-inf 0],(muS-mus),(sqrt(devS^2+devs^2)));
hold on
plot(Xvalues,npdfS,'g','linewidth',2)
plot(Xvalues,npdfs,'r','linewidth',2)
plot(Xvalues,npdfz,'b','linewidth',2)
grid on
xlabel('Sollecitazione/Resistenza [stress units]')
ylabel('f(x) PDF')
str = ['Probability Fail is ',num2str(p)];
title(str)

Sk_P=norminv(0.05,muS,devS)
sk_P=norminv(0.95,mus,devs)
Sd_P=(Sk_P/gammaS)
sd_P=(sk_P*gammas)
gammakS=muS/Sk_P
gammaks=sk_P/mus
gammadS=muS/Sd_P
gammads=sd_P/mus

gamma=1
gammak=Sk_P/sk_P
gammad=Sd_P/sd_P

[fxy,FXY,pM,PM,FM]=joint_distribution(mus,devs,muS,devS,Xvalues,gamma,0);
PM
[fxyk,FXYk,pMk,PMk,FMk]=joint_distribution(mus,devs,muS,devS,Xvalues,gammak,0);
PMk
[fxyd,FXYd,pMd,PMd,FMd]=joint_distribution(mus,devs,muS,devS,Xvalues,gammad,1);
PMd

