clc
clear all
close all

Cs=0.3
CS=0.1;
meansps=700;
devstdsps=Cs*meansps;
Popolations=1000;
meanspS=1000;
devstdspS=CS*meanspS;
PopolationS=1000;

x=[0:50:3000];
xSs=[-3000:50:3000];

Rs = normrnd(meansps,devstdsps,Popolations,1);
RS = normrnd(meanspS,devstdspS,PopolationS,1);
RSs=RS-Rs;

[Occurrencess,Xvalues]=hist(Rs,x);
[OccurrencesS,Xvalues]=hist(RS,x);
[OccurrencesSs,XvaluesSs]=hist(RSs,xSs);

mus=mean(Rs);
devs=std(Rs);
Cs=devs/mus;
muS=mean(RS);
devS=std(RS);
CS=devS/muS;

Cn = sqrt((CS^2+Cs^2)/(1+Cs^2));

%__________________________________________________

%pdf sperimentale
sper_pdfs=Occurrencess./Popolations./mean(diff(Xvalues));
sper_pdfS=OccurrencesS./PopolationS./mean(diff(Xvalues));
sper_pdfSs=OccurrencesSs./PopolationS./mean(diff(XvaluesSs));


npdfS=normpdf(Xvalues,muS,devS);
npdfs=normpdf(Xvalues,mus,devs);
npdfSs=normpdf(XvaluesSs,(muS-mus),(sqrt(devS^2+devs^2)));

for i=1:length(Xvalues),
   sper_pdfz(i,:)=sper_pdfS(i)*sper_pdfs;
   npdfz(i,:)=npdfS(i)*npdfs;
end

nmed=muS/mus

% zn=-(muS-mus)/sqrt(devS^2+devs^2)
% Pn=normcdf(zn,0,1);
% Rn=1-Pn

[zn,Rn]=eqacc_norm(muS,devS,mus,devs)

% zln=-(log((muS/mus)*sqrt((1+Cs^2)/(1+CS^2)))/sqrt(log((1+CS^2)*(1+Cs^2))))
% Pln=normcdf(zln,0,1);
% Rln=1-Pln

[zln,Rln]=eqacc_logn(muS,CS,mus,Cs)

Rext=0.95;
Pext=1-Rext;
zext=norminv(Pext,0,1);

R=Rext;
z=zext;

if R>=0.5
    a=1;
else
    a=-1;
end

n=(1+(a)*sqrt(1-(1-z^2*CS^2)*(1-z^2*Cs^2)))/(1-z^2*CS^2)
nd=exp(Cn*(-z+Cn/2))

ProbabilityS=0.05;
Probabilitys=0.95;

Sk_P=norminv(ProbabilityS,muS,devS);
sk_P=norminv(Probabilitys,mus,devs);
S_p=normpdf(Sk_P,muS,devS);
s_p=normpdf(sk_P,mus,devs);

gammakS=muS/Sk_P;
gammaks=sk_P/mus;
CoeffSick=gammaks*gammakS

gammaS=1.1*gammakS;
gammas=1.1*gammaks;
Sd=muS/gammaS;
sd=mus*gammas;
CoeffSicd=gammas*gammaS

figid=0;

gamma=1;
[fxy,FXY,pM,PM,FM]=joint_distribution_alfa(sper_pdfs,sper_pdfS,Xvalues,gamma,figid);
PM
gamma=Sk_P/sk_P;
[fxy,FXY,pMk,PMk,FMk]=joint_distribution_alfa(sper_pdfs,sper_pdfS,Xvalues,gamma,figid);
PMk
gamma=Sd/sd;
[fxy,FXY,pMd,PMd,FMd]=joint_distribution_alfa(sper_pdfs,sper_pdfS,Xvalues,gamma,figid);
PMd

%%

figure(1)
surf(Xvalues,Xvalues,sper_pdfz)
hold on
xlabel('Sollecitazione (s) [stress units]')
ylabel('Resistenza (S) [stress units]')
zlabel('f(x) PDF')
title('Funzione di densit di Probabilit Congiunta')
plot3(Xvalues,ones(length(Xvalues),1)*0,npdfs*(max(max(npdfz))/max(npdfs)),'k','linewidth',1)
plot3(Xvalues,ones(length(Xvalues),1)*0,sper_pdfs*(max(max(npdfz))/max(npdfs)),'k')
plot3(ones(length(Xvalues),1)*0,Xvalues,npdfS*(max(max(npdfz))/max(npdfS)),'k','linewidth',1)
plot3(ones(length(Xvalues),1)*0,Xvalues,sper_pdfS*(max(max(npdfz))/max(npdfS)),'k')
plot3(diag(Xvalues),diag(Xvalues),ones(length(Xvalues),1)*0,'w','linewidth',2)

plot3(diag(Xvalues)*sd,diag(Xvalues)*Sd,ones(length(Xvalues),1)*0,'r','linewidth',2)
hold on
plot3(diag(Xvalues)*sk_P,diag(Xvalues)*Sk_P,ones(length(Xvalues),1)*0,'b','linewidth',2)
% plot3(0,S_P,S_p*(max(max(npdfsS))/max(npdfS)),'ro','linewidth',2)
% plot3(s_P,0,s_p*(max(max(npdfsS))/max(npdfs)),'bo','linewidth',2)
plot3(ones(length(Xvalues),1)*sk_P,Xvalues,ones(length(Xvalues),1)*0,'b','linewidth',1)
plot3(Xvalues,ones(length(Xvalues),1)*Sk_P,ones(length(Xvalues),1)*0,'b','linewidth',1)
plot3(ones(length(Xvalues),1)*sd,Xvalues,ones(length(Xvalues),1)*0,'r','linewidth',1)
plot3(Xvalues,ones(length(Xvalues),1)*Sd,ones(length(Xvalues),1)*0,'r','linewidth',1)
S=axis;
axis([Xvalues(1) Xvalues(end) Xvalues(1) Xvalues(end) S(5) S(6)])

%%

figure(2)
contour3(Xvalues,Xvalues,sper_pdfz,50)
hold on
grid on
xlabel('Sollecitazione (s) [stress units]')
ylabel('Resistenza (S) [stress units]')
zlabel('f(x) PDF')
title('Funzione di densit di Probabilit Congiunta')
plot3(Xvalues,ones(length(Xvalues),1)*0,npdfs*(max(max(npdfz))/max(npdfs)),'k','linewidth',1)
plot3(Xvalues,ones(length(Xvalues),1)*0,sper_pdfs*(max(max(npdfz))/max(npdfs)),'k')
plot3(ones(length(Xvalues),1)*0,Xvalues,npdfS*(max(max(npdfz))/max(npdfS)),'k','linewidth',1)
plot3(ones(length(Xvalues),1)*0,Xvalues,sper_pdfS*(max(max(npdfz))/max(npdfS)),'k')
plot3(diag(Xvalues),diag(Xvalues),ones(length(Xvalues),1)*0,'k','linewidth',2)

plot3(diag(Xvalues)*sd,diag(Xvalues)*Sd,ones(length(Xvalues),1)*0,'r','linewidth',2)
hold on
plot3(diag(Xvalues)*sk_P,diag(Xvalues)*Sk_P,ones(length(Xvalues),1)*0,'b','linewidth',2)
% plot3(0,S_P,S_p*(max(max(npdfsS))/max(npdfS)),'ro','linewidth',2)
% plot3(s_P,0,s_p*(max(max(npdfsS))/max(npdfs)),'bo','linewidth',2)
plot3(ones(length(Xvalues),1)*sk_P,Xvalues,ones(length(Xvalues),1)*0,'b','linewidth',1)
plot3(Xvalues,ones(length(Xvalues),1)*Sk_P,ones(length(Xvalues),1)*0,'b','linewidth',1)
plot3(ones(length(Xvalues),1)*sd,Xvalues,ones(length(Xvalues),1)*0,'r','linewidth',1)
plot3(Xvalues,ones(length(Xvalues),1)*Sd,ones(length(Xvalues),1)*0,'r','linewidth',1)
S=axis;
axis([Xvalues(1) Xvalues(end) Xvalues(1) Xvalues(end) S(5) S(6)])

%%

normspec([-inf 0],(muS-mus),(sqrt(devS^2+devs^2)));
hold on
plot(Xvalues,npdfS,'g','linewidth',2)
plot(Xvalues,sper_pdfS,'g','linewidth',1)
plot(Xvalues,npdfs,'r','linewidth',2)
plot(Xvalues,sper_pdfs,'r','linewidth',1)
plot(XvaluesSs,npdfSs,'b','linewidth',2)
plot(XvaluesSs,sper_pdfSs,'b','linewidth',1)
grid on
xlabel('Sollecitazione/Resistenza [stress units]')
ylabel('f(x) PDF')
title('Probability Density Functions')

%%

X1=Rs;
X2=RS;
[n1,ctr1] = hist(X1,20);
[n2,ctr2] = hist(X2,20);

figure(4)
subplot(2,2,2); plot(X1,X2,'.');axis([Xvalues(1)  Xvalues(end) Xvalues(1)  Xvalues(end)]); h1 = gca;
title('Simulated Dependent Sigma and Strength Values');
xlabel('X1 ~ Sigma'); ylabel('X2 ~ Strength');
hold on
contour3(Xvalues,Xvalues,sper_pdfz,50)
plot(Xvalues,Xvalues,'k','linewidth',2)
plot(diag(Xvalues)*sd,diag(Xvalues)*Sd,'r','linewidth',2)
plot(diag(Xvalues)*sk_P,diag(Xvalues)*Sk_P,'b','linewidth',2)
plot(ones(length(Xvalues),1)*sk_P,Xvalues,'b','linewidth',1)
plot(Xvalues,ones(length(Xvalues),1)*Sk_P,'b','linewidth',1)
plot(ones(length(Xvalues),1)*sd,Xvalues,'r','linewidth',1)
plot(Xvalues,ones(length(Xvalues),1)*Sd,'r','linewidth',1)
S=axis;
axis([Xvalues(1) Xvalues(end) Xvalues(1) Xvalues(end)])
subplot(2,2,4); bar(ctr1,-n1/sum(n1)/mean(diff(ctr1)),1); axis([Xvalues(1)  Xvalues(end) -max(n1/sum(n1)/mean(diff(ctr1)))*1.1 0]); h2 = gca; %axis('off');
hold on
subplot(2,2,1); barh(ctr2,-n2/sum(n2)/mean(diff(ctr2)),1); axis([-max(n2/sum(n2)/mean(diff(ctr2)))*1.1 0 Xvalues(1)  Xvalues(end)]); h3 = gca; %axis('off');
hold on
subplot(2,2,4); plot(Xvalues,-sper_pdfs); axis([Xvalues(1)  Xvalues(end) -max(sper_pdfs)*1.1 0]); h2 = gca;
subplot(2,2,4); plot(Xvalues,-npdfs); axis([Xvalues(1)  Xvalues(end) -max(npdfs)*1.1 0]); h2 = gca;
subplot(2,2,1); plot(-sper_pdfS,Xvalues); axis([-max(sper_pdfS)*1.1 0 Xvalues(1)  Xvalues(end)]); h3 = gca; 
subplot(2,2,1); plot(-npdfS,Xvalues); axis([-max(npdfS)*1.1 0 Xvalues(1)  Xvalues(end)]); h3 = gca; 
set(h1,'Position',[0.35 0.35 0.55 0.55]);
set(h2,'Position',[.35 .1 .55 .15]);
set(h3,'Position',[.1 .35 .15 .55]);
% colormap([.8 .8 1]);

%%

figure(5)
surf(Xvalues,Xvalues,pMk)
hold on
xlabel('Sollecitazione (s) [stress units]')
ylabel('Resistenza (S) [stress units]')
zlabel('f(x) PDF')
title('Funzione di densit di Probabilit Congiunta')
plot3(Xvalues,ones(length(Xvalues),1)*0,npdfs*(max(max(npdfz))/max(npdfs)),'k','linewidth',1)
plot3(Xvalues,ones(length(Xvalues),1)*0,sper_pdfs*(max(max(npdfz))/max(npdfs)),'k')
plot3(ones(length(Xvalues),1)*0,Xvalues,npdfS*(max(max(npdfz))/max(npdfS)),'k','linewidth',1)
plot3(ones(length(Xvalues),1)*0,Xvalues,sper_pdfS*(max(max(npdfz))/max(npdfS)),'k')
plot3(diag(Xvalues),diag(Xvalues),ones(length(Xvalues),1)*0,'w','linewidth',2)
plot3(diag(Xvalues)*sd,diag(Xvalues)*Sd,ones(length(Xvalues),1)*0,'r','linewidth',2)
hold on
plot3(diag(Xvalues)*sk_P,diag(Xvalues)*Sk_P,ones(length(Xvalues),1)*0,'b','linewidth',2)
% plot3(0,S_P,S_p*(max(max(npdfsS))/max(npdfS)),'ro','linewidth',2)
% plot3(s_P,0,s_p*(max(max(npdfsS))/max(npdfs)),'bo','linewidth',2)
plot3(ones(length(Xvalues),1)*sk_P,Xvalues,ones(length(Xvalues),1)*0,'b','linewidth',1)
plot3(Xvalues,ones(length(Xvalues),1)*Sk_P,ones(length(Xvalues),1)*0,'b','linewidth',1)
plot3(ones(length(Xvalues),1)*sd,Xvalues,ones(length(Xvalues),1)*0,'r','linewidth',1)
plot3(Xvalues,ones(length(Xvalues),1)*Sd,ones(length(Xvalues),1)*0,'r','linewidth',1)
S=axis;
axis([Xvalues(1) Xvalues(end) Xvalues(1) Xvalues(end) S(5) S(6)])

%%

figure(6)
subplot(2,2,2); contour3(Xvalues,Xvalues,pMd,50);axis([Xvalues(1)  Xvalues(end) Xvalues(1)  Xvalues(end)]); h1 = gca;
title('Simulated Dependent Sigma and Strength Values');
xlabel('X1 ~ Sigma'); ylabel('X2 ~ Strength');
hold on
subplot(2,2,2); plot(X1,X2,'.');axis([Xvalues(1)  Xvalues(end) Xvalues(1)  Xvalues(end)]); h1 = gca;
%subplot(2,2,2); contour3(Xvalues,Xvalues,pMd,50);axis([Xvalues(1)  Xvalues(end) Xvalues(1)  Xvalues(end)]);
%subplot(2,2,2); contour3(Xvalues,Xvalues,sper_pdfz,50);axis([Xvalues(1)  Xvalues(end) Xvalues(1)  Xvalues(end)]); h1 = gca;
plot(Xvalues,Xvalues,'k','linewidth',2)
plot(diag(Xvalues)*sd,diag(Xvalues)*Sd,'r','linewidth',2)
plot(diag(Xvalues)*sk_P,diag(Xvalues)*Sk_P,'b','linewidth',2)
plot(ones(length(Xvalues),1)*sk_P,Xvalues,'b','linewidth',1)
plot(Xvalues,ones(length(Xvalues),1)*Sk_P,'b','linewidth',1)
plot(ones(length(Xvalues),1)*sd,Xvalues,'r','linewidth',1)
plot(Xvalues,ones(length(Xvalues),1)*Sd,'r','linewidth',1)
S=axis;
axis([Xvalues(1) Xvalues(end) Xvalues(1) Xvalues(end)])
subplot(2,2,4); bar(ctr1,-n1/sum(n1)/mean(diff(ctr1)),1); axis([Xvalues(1)  Xvalues(end) -max(n1/sum(n1)/mean(diff(ctr1)))*1.1 0]); h2 = gca; %axis('off');
hold on
subplot(2,2,1); barh(ctr2,-n2/sum(n2)/mean(diff(ctr2)),1); axis([-max(n2/sum(n2)/mean(diff(ctr2)))*1.1 0 Xvalues(1)  Xvalues(end)]); h3 = gca; %axis('off');
hold on
subplot(2,2,4); plot(Xvalues,-sper_pdfs); axis([Xvalues(1)  Xvalues(end) -max(sper_pdfs)*1.1 0]); h2 = gca;
subplot(2,2,4); plot(Xvalues,-npdfs); axis([Xvalues(1)  Xvalues(end) -max(npdfs)*1.1 0]); h2 = gca;
subplot(2,2,1); plot(-sper_pdfS,Xvalues); axis([-max(sper_pdfS)*1.1 0 Xvalues(1)  Xvalues(end)]); h3 = gca; 
subplot(2,2,1); plot(-npdfS,Xvalues); axis([-max(npdfS)*1.1 0 Xvalues(1)  Xvalues(end)]); h3 = gca; 
set(h1,'Position',[0.35 0.35 0.55 0.55]);
set(h2,'Position',[.35 .1 .55 .15]);
set(h3,'Position',[.1 .35 .15 .55]);
%colormap([.8 .8 1]);

%%

figure(7)
subplot(2,2,2); contour3(Xvalues,Xvalues,pM,50);axis([Xvalues(1)  Xvalues(end) Xvalues(1)  Xvalues(end)]); h1 = gca;
title('Simulated Dependent Sigma and Strength Values');
xlabel('X1 ~ Sigma'); ylabel('X2 ~ Strength');
hold on
subplot(2,2,2); plot(X1,X2,'.');axis([Xvalues(1)  Xvalues(end) Xvalues(1)  Xvalues(end)]); h1 = gca;
%subplot(2,2,2); contour3(Xvalues,Xvalues,pM,50);axis([Xvalues(1)  Xvalues(end) Xvalues(1)  Xvalues(end)]);
%subplot(2,2,2); contour3(Xvalues,Xvalues,sper_pdfz,50);axis([Xvalues(1)  Xvalues(end) Xvalues(1)  Xvalues(end)]); h1 = gca;
plot(Xvalues,Xvalues,'k','linewidth',2)
S=axis;
axis([Xvalues(1) Xvalues(end) Xvalues(1) Xvalues(end)])
subplot(2,2,4); bar(ctr1,-n1/sum(n1)/mean(diff(ctr1)),1); axis([Xvalues(1)  Xvalues(end) -max(n1/sum(n1)/mean(diff(ctr1)))*1.1 0]); h2 = gca; %axis('off');
hold on
subplot(2,2,1); barh(ctr2,-n2/sum(n2)/mean(diff(ctr2)),1); axis([-max(n2/sum(n2)/mean(diff(ctr2)))*1.1 0 Xvalues(1)  Xvalues(end)]); h3 = gca; %axis('off');
hold on
subplot(2,2,4); plot(Xvalues,-sper_pdfs); axis([Xvalues(1)  Xvalues(end) -max(sper_pdfs)*1.1 0]); h2 = gca;
subplot(2,2,4); plot(Xvalues,-npdfs); axis([Xvalues(1)  Xvalues(end) -max(npdfs)*1.1 0]); h2 = gca;
subplot(2,2,1); plot(-sper_pdfS,Xvalues); axis([-max(sper_pdfS)*1.1 0 Xvalues(1)  Xvalues(end)]); h3 = gca; 
subplot(2,2,1); plot(-npdfS,Xvalues); axis([-max(npdfS)*1.1 0 Xvalues(1)  Xvalues(end)]); h3 = gca; 
set(h1,'Position',[0.35 0.35 0.55 0.55]);
set(h2,'Position',[.35 .1 .55 .15]);
set(h3,'Position',[.1 .35 .15 .55]);
%colormap([.8 .8 1]);

%%
