close all
clear all


%Definizione parametri dinamici
T=1000; %Durata (s) del disturbo random
dt=0.01; %Passo di integrazione o ricostruzione della TH
t=(0:dt:T)'; %Vettore del tempo
df=0.01; %Passo di discertizzazione del vettore della frequenza
maxfreq=1/(2*dt); %Frequenza di Nyquist
freq=df:df:maxfreq; %Vettore della Frequenza
w=2*pi*freq;
fft_point=8192; %punti da utilizzare per l'analisi FFT

f0=0.01;
w0=2*pi*f0;
m=250; %Massa 1
csi=0.01;
b=2*m*csi*w0; %Smorzamento 1

%State Space
A=[0 1; -w0^2 -b/m];
B=[0; 1/m];
C=[1*1e5 0];
D=0;
SYS=ss(A,B,C,D);
%Generazione della FRF
[mag,phase]=bode(SYS,w);

%Definizione PSD dell'ingresso
Sn=0*ones(length(freq),1);
for i=1:length(freq),
    Sn(i)=1; %(units)^2/Hz
end
PSDu=Sn; %Disturbo PSD

% Analisi dinamica in frequenza (PSD)
MAG=squeeze(mag(1,1,:));
PSDoutput=PSDu.*MAG.^2;

figure
loglog(freq,PSDoutput)
grid on

%Ricostruzione del segnale di output a partire dalla PSD di output
S = struct('S',(1)/(2*pi)*PSDoutput,'w',2*pi*freq','tr',[],'h',[],'type','freq','phi',0,'norm',0,'note','..','date','..','L',400,'Bw',1.2535e+001);
% S = struct('S',(1)/(2*pi)*PSDu,'w',2*pi*freq','tr',[],'h',[],'type','freq','phi',0,'norm',0,'note','..','date','..','L','..','Bw','..');
P=T/dt;
itime=spec2sdat(S,P,dt);

figure
plot(itime(:,1),itime(:,2))
grid on

% Estrazione della funzione di auto-correlazione
[xcor,xlags] = xcorr(itime(:,2),'none');

figure
plot(xlags,xcor/P,'r')
hold on
grid on
ylabel('correlation function')
xlabel('units')

xcorr_rms=xcor(P)/P
std(itime(:,2))^2


