   function [speceqv,Mom] = dirlik(f,psd,Dsig)
%
% [speceqv,Mom] = dirlik(f,psd,Dsig)
% INPUT:
% f:		vettore delle frequenze (in Hz) 
% psd:   	psd di tensione (in Pa^2/Hz)
% Dsig: 	Delta sigma per Ia divisione dello spettro di carico
% OUTPUT:
% Speceqv:	spettro di carico equivalente 
% Mom:	    momenti della psd di tensione
% La funzione  utilizzata per analisi frequency domain.
%
%   F.Cianetti 
%   Copyright 2004-2010 COSMAC 
%   $Revision: 1.0 $  $Date: 01/09/04 

   w = 2*pi*f;
   S = struct('S',1/(2*pi)*psd,'w',w','tr',[],'h',[],'type','freq','phi',0,'norm',0,'note','...','date','..','L',400,'Bw',1.2535e+001);

   Mom = spec2mom(S,4,'',0);
  
   for i=1:length(Mom)
       Mom(i)=Mom(i)/(2*pi)^(i-1);
   end

   M0=Mom(1);
   gam=Mom(3)/sqrt(Mom(1)*Mom(5));
   xm=(Mom(2)/Mom(1))*sqrt(Mom(3)/Mom(5));
   D1=(2*(xm-gam^2))/(1+gam^2);
   R=(gam-xm-D1^2)/(1-gam-D1+D1^2);
   D2=((1-gam-D1+D1^2)/(1-R));
   D3=1-D1-D2;
   Q=1.25*(gam-D3-D2*R)/D1;
%   massi=floor(12*sqrt(M0));
   massi=(12*sqrt(M0));
   RANGE=[0:Dsig:massi];
   for i=1:length(RANGE)
       Z(i)=RANGE(i)/(2*sqrt(M0));
       P(i)=(D1/Q)*exp(-Z(i)/Q)+(D2*Z(i)/R^2)*exp((-Z(i)^2)/(2*R^2))+D3*Z(i)*exp((-Z(i)^2)/2);
       p(i)=P(i)/(2*sqrt(M0));
       n(i)=p(i);
   end
   
   n=n';
%   n=n*sqrt(Mom(5)/Mom(3));
   AMP=RANGE/2;
   speceqv=[2*n, AMP'];
   
   