function [fxy,FXY,pM,PM,FM]=joint_distribution(mus,devs,muS,devS,Xvalues,gamma,figid)

CS =  devS/muS;
Cs =  devs/mus;

Deltavalues=mean(diff(Xvalues));
svalues=Xvalues;
Svalues=Xvalues;

npdfs=normpdf(svalues,mus,devs);
npdfS=normpdf(Svalues,muS,devS);
for i=1:length(svalues),
    npdfsS(i,:)=npdfS(i)*npdfs;
end

x = svalues;
y = Svalues;
fxy = npdfsS;
[t,u] = meshgrid(x,y);
% G = input('Enter expression for g(t,u): i.e. (t*gamma-u) ');
G = t*gamma - u;
M = G >= 0;
N = G < 0;
pM=M.*fxy;
pN=N.*fxy;
PM=sum(sum(pM)*Deltavalues)*Deltavalues;
PN=sum(sum(pN)*Deltavalues)*Deltavalues;

FXY = flipud(cumsum(flipud(fxy)));
FXY = (cumsum(FXY')').*Deltavalues^2;
FM=flipud(cumsum(flipud(pM)));
FM=(cumsum(FM')').*Deltavalues^2;
FN=flipud(cumsum(flipud(pN)));
FN=(cumsum(FN')').*Deltavalues^2;

if figid ==1

    figure
    contour3(Xvalues,Xvalues,fxy,50);
    cmap=colorbar;
    title('Joint Probability Distribution');
    xlabel('X1 ~ Sigma'); ylabel('X2 ~ Strength');
    hold on
    colorbar(cmap)

    figure
    contour3(Xvalues,Xvalues,FXY,50);
    cmap=colorbar;
    title('Joint Probability Cumulation');
    xlabel('X1 ~ Sigma'); ylabel('X2 ~ Strength');
    hold on
    colorbar(cmap)

    figure
    subplot(2,2,2); contour3(Xvalues,Xvalues,pM,50) ;axis([Xvalues(1) Xvalues(end) Xvalues(1) Xvalues(end)]); h1 = gca;
    cmap=colorbar;
    title('Joint Probability Distribution');
    xlabel('X1 ~ Sigma'); ylabel('X2 ~ Strength');
    hold on
    plot(Xvalues,Xvalues,'k','linewidth',2)
    plot(diag(Xvalues)/gamma,diag(Xvalues),'r','linewidth',2)
    S=axis;
    axis([Xvalues(1) Xvalues(end) Xvalues(1) Xvalues(end)])
    subplot(2,2,4); plot(Xvalues,-npdfs); axis([Xvalues(1) Xvalues(end) -max(npdfs)*1.1 0]); grid on; h2 = gca;
    subplot(2,2,1); plot(-npdfS,Xvalues); axis([-max(npdfS)*1.1 0 Xvalues(1) Xvalues(end)]); grid on; h3 = gca; 
    set(h1,'Position',[0.35 0.35 0.55 0.55]);
    set(h2,'Position',[.35 .1 .55 .15]);
    set(h3,'Position',[.1 .35 .15 .55]);

    figure
    subplot(2,2,2); contour3(Xvalues,Xvalues,FM,50) ;axis([Xvalues(1) Xvalues(end) Xvalues(1) Xvalues(end)]); h1 = gca;
    cmap=colorbar;
    title('Joint Probability Distribution');
    xlabel('X1 ~ Sigma'); ylabel('X2 ~ Strength');
    hold on
    plot(Xvalues,Xvalues,'k','linewidth',2)
    plot(diag(Xvalues)/gamma,diag(Xvalues),'r','linewidth',2)
    S=axis;
    axis([Xvalues(1) Xvalues(end) Xvalues(1) Xvalues(end)])
    subplot(2,2,4); plot(Xvalues,-npdfs); axis([Xvalues(1) Xvalues(end) -max(npdfs)*1.1 0]); grid on; h2 = gca;
    subplot(2,2,1); plot(-npdfS,Xvalues); axis([-max(npdfS)*1.1 0 Xvalues(1) Xvalues(end)]); grid on; h3 = gca; 
    set(h1,'Position',[0.35 0.35 0.55 0.55]);
    set(h2,'Position',[.35 .1 .55 .15]);
    set(h3,'Position',[.1 .35 .15 .55]);

end


