   function [speceqv,Mom] = rayleigh(f,psd,Dsig)
%
% [speceqv,Mom] = rayleigh(f,psd,Dsig)
% INPUT:
% f:		vettore delle frequenze (in Hz) 
% psd:   	psd di tensione (in Pa^2/Hz)
% Dsig: 	Delta sigma per Ia divisione dello spettro di carico
% OUTPUT:
% Speceqv:	spettro di carico equivalente 
% Mom:	    momenti della psd di tensione
% La funzione  utilizzata per analisi frequency domain.
%
%   F.Cianetti 
%   Copyright 2004-2010 COSMAC 
%   $Revision: 1.0 $  $Date: 01/09/04 

   w = 2*pi*f;
   S = struct('S',1/(2*pi)*psd,'w',w','tr',[],'h',[],'type','freq','phi',0,'norm',0,'note','...','date','..','L',400,'Bw',1.2535e+001);

   Mom = spec2mom(S,4,'',0);
  
   for i=1:length(Mom)
       Mom(i)=Mom(i)/(2*pi)^(i-1);
   end

   M0=Mom(1);
%   massi=floor(12*sqrt(M0));
   massi=(12*sqrt(M0));
   RANGE=[0:Dsig:massi];
   for i=1:length(RANGE)
       Z(i)=(RANGE(i)/(4*M0))*exp(-(RANGE(i)^2/(8*M0)));
       Z(i)=Z(i);
   end
   Z=Z';
   %Z=Z*sqrt(Mom(5)/Mom(3));
   AMP=RANGE/2;
   speceqv=[Z*2, AMP'];
   
   