   function [Mom_f,Mom] = statPSD(f,psd)
%
% [Mom] = statPSD(f,psd)
% INPUT:
% f:		vettore delle frequenze (in Hz) 
% psd:   	psd di tensione (in Pa^2/Hz)
% OUTPUT:
% Mom:	    momenti della psd di tensione
% La funzione  utilizzata per analisi frequency domain.
%
%   F.Cianetti 
%   Copyright 2004-2010 COSMAC 
%   $Revision: 1.0 $  $Date: 01/09/04 

   w = 2*pi*f;
   S = struct('S',1/(2*pi)*psd,'w',w','tr',[],'h',[],'type','freq','phi',0,'norm',0,'note','...','date','..','L',400,'Bw',1.2535e+001);

   Mom = spec2mom(S,4,'',0);
  
   for i=1:length(Mom)
       Mom_f(i)=Mom(i)/(2*pi)^(i-1);
   end

