clc
close all
clear all
 
 E=2.0e5;      
 Sut=724;

%Monotonic loading
 n=0.13;      
%K=sf/(ef)^n;
 K=1145;
 sf=1227;     
 ef=1.04;     

%Cyclic loading
 ns=0.18;    
%Ks=sfs/(efs)^ns;
 Ks=1344;
 sfs=1227;    
 efs=1.00;    
 b=-0.095;
 c=-0.66;
 Plots=1;
  
 smin=-700;
 smax=700;
 sm=(smax+smin)/2;
 sa=(smax-smin)/2;
 material_e1(Sut,E,n,K,sf,ef,ns,Ks,sfs,efs,sa,sm,Plots);
 
 smin=-500;
 smax=500;
 sm=(smax+smin)/2;
 sa=(smax-smin)/2;
 material_e1(Sut,E,n,K,sf,ef,ns,Ks,sfs,efs,sa,sm,Plots);

  s=[0 -700 0 -700 400 -700 600 -700 700 0 700 -400 700 -600 700 -700];
% s=[0 -700 0 -700];

 sizes=100;
 segno=ones(sizes,1)';
 segno(1)=-sign(s(end));
 for i=2:length(segno),
     segno(i)=-segno(i-1);
 end    
 
 srand=(abs(randn(sizes,1)*Sut/2)'.*segno);
 s=[s srand];
 
 Slimit=720;
 G = abs(s) - Slimit;
 M = G >= 0;
 for i=1:length(M);
     if M(i)==1
         s(i)=Slimit*sign(s(i));
     end
 end

 figure(3)
 plot(s,'ro')
 hold on
 plot(s)
 grid on
 title('Stress history')
 xlabel('measurement points')
 ylabel('sigma (stress unit)')

 ee=s(1)/E+(s(1)/Ks)^(1/ns);
 for i=1:max(size(s))-1,
     sinit=s(i);
     send=s(i+1);
     [ei,ee]=material_e2(Sut,E,n,K,sf,ef,ns,Ks,sfs,efs,sinit,send,ee,Plots);
     e(i:i+1)=[ei ee];
 end

 figure(4)
 plot(e,s,'or')
 
 sm=0;
 [N,Ea,Nt,Eat] = material_e3(Sut,E,sm,sfs,efs,b,c,Plots);
 Nt
 sm=500;
 [N,Ea,Nt,Eat] = material_e3(Sut,E,sm,sfs,efs,b,c,Plots);
 Nt

 Kt=2;
 q=0.6;
 Snom=100;
 Plots=0;
 [Kss,Ke,Kf,emax,smax]=material_e4(Sut,E,Kt,q,Snom,ns,Ks,sfs,efs,Plots);
 error=abs(((Ke*Kss)-Kf^2)/(Kf^2))*100
 
Plots=0;
Kt=2;
q=0.6;
Kf=1+q*(Kt-1);
ii=0;
for i=1:max(size(s)),
     ii=ii+1;
     if abs(s(i)) > 0
         sv(i)=Kf*s(i);
         en(i)=s(i)/E;
         ev(i)=sv(i)/E;
         [Kss,Ke,Kf,emax,smax]=material_e4(Sut,E,Kt,q,abs(s(i)),ns,Ks,sfs,efs,Plots);
         svp(i)=smax*sign(s(i));
         evp(i)=emax*sign(s(i));
         KE(ii)=Ke;
         KS(ii)=Kss;
     else
         KE(ii)=0;
         KS(ii)=0;
     end
end

figure
plot(sv,'r')
hold on
grid on
plot(svp,'k','linewidth',2)
title('Stress history')
xlabel('measurement points')
ylabel('sigma (stress unit)')
plot(s)

figure
plot(ev,'r')
hold on
grid on
plot(evp,'k','linewidth',2)
title('Epsilon history')
xlabel('measurement points')
ylabel('Epsilon (no unit)')
plot(en)

figure
plot(abs(s),KE,'or')
grid on
hold on
plot(abs(s),KS,'bo')
title('K history')
xlabel('Nominal Stress (stress unit)')
ylabel('K (no unit)')

