function [] = material_e1(Sut,E,n,K,sf,ef,ns,Ks,sfs,efs,sa,sm,Plots)


% E      Elastic modulus
% Sut    Ultimate tensile strength

%Monotonic loading
% n      
% K      
% sf     
% ef     

%Cyclic loading
% ns    
% Ks      
% sfs    
% efs    

% sa     stress amplitude
% sm     mean stress

%________________________________

%S-E curve
s_c=0:Sut/100:Sut;

%K=sf/(ef)^n;
%Ks=sfs/(efs)^ns;

for i=1:length(s_c),
    e_c(i)=s_c(i)/E+(s_c(i)/K)^(1/n);
    es_c(i)=s_c(i)/E+(s_c(i)/Ks)^(1/ns);
end
%________________________________

%________________________________

%Hysterethic loop
smax=sm+sa;
smin=sm-sa;
emax=smax/E+(smax/Ks)^(1/ns);
emin=smin/E+(smin/Ks)^(1/ns);

sl=0:abs(smax)/100:smax;

for i=1:length(sl),
    el_1(i)=sl(i)/E+(sl(i)/Ks)^(1/ns);
end

Ds=0:abs(smax-smin)/100:(smax-smin);
for i=1:length(Ds),
    Der_1(i)=abs(Ds(i))/E+2*(abs(Ds(i))/(2*Ks))^(1/ns);
end
er_1=emax-Der_1;
el_2=er_1(length(er_1))+Der_1;

if Plots==1,

figure(1)
hold on
plot(e_c,s_c)
plot(es_c,s_c,'r','linewidth',2)
plot(es_c,Sut*ones(length(es_c),1),'k--')
grid on
title('Stress-Strain Surve for monotically (b) and cycling (r) loading')
xlabel('strain')
ylabel('sigma (stress unit)')

figure(2)
hold on
plot(el_1,sl,'r')
plot(er_1,smax-Ds,'r')
plot(el_2,smin+Ds,'r')
grid on
title('Hysteresis Loop')
xlabel('strain')
ylabel('sigma (stress unit)')

end