function [einit,eend] = material_e2(Sut,E,n,K,sf,ef,ns,Ks,sfs,efs,sinit,send,eprev,Plots)


% E      Elastic modulus
% Sut    Ultimate tensile strength

%Monotonic loading
% n      
% K      
% sf     
% ef     

%Cyclic loading
% ns    
% Ks      
% sfs    
% efs    

%sinit   Initial stress
%send    Ending stress
%eprev   Previous strain

% Plots  plot S-E curve

%________________________________

%S-E curve
s_c=0:Sut/100:Sut;

%K=sf/(ef)^n;
%Ks=sfs/(efs)^ns;

for i=1:length(s_c),
    e_c(i)=s_c(i)/E+(s_c(i)/K)^(1/n);
    es_c(i)=s_c(i)/E+(s_c(i)/Ks)^(1/ns);
end
%________________________________

%________________________________

%Hysterethic loop
if sinit==0,
    sinit=1e-3;
    if eprev==0,
        sl=0:abs(send)/100:abs(send);
        for i=1:length(sl),
            el_1(i)=sl(i)/E+(sl(i)/Ks)^(1/ns);
        end
        eend=el_1(end)*(send/abs(send));
        figure(4)
        plot(el_1*(send/abs(send)),sl*(send/abs(send)),'r')
        hold on
        plot(es_c,s_c,'k','linewidth',2)
        plot(-es_c,-s_c,'k','linewidth',2)
        grid on
        title('Hysteresis Loops History')
        xlabel('strain')
        ylabel('sigma (stress unit)')
        einit=eprev;
        Ds=abs(send-sinit);

    else

        einit=eprev;

        Ds=0:abs(send-sinit)/100:abs(send-sinit);
        for i=1:length(Ds),
            Der_1(i)=abs(Ds(i))/E+2*(abs(Ds(i))/(2*Ks))^(1/ns);
        end
        if sinit > send,
            er_1=einit-Der_1;
        else
            er_1=einit+Der_1;
        end

        eend=er_1(length(er_1));

        if Plots==1,
            figure(4)
            hold on
            if sinit > send,
                plot(er_1,sinit-Ds,'r')
            else
                plot(er_1,sinit+Ds,'r')
            end
            plot(es_c,s_c,'k','linewidth',2)
            plot(-es_c,-s_c,'k','linewidth',2)
            grid on
            title('Hysteresis Loops History')
            xlabel('strain')
            ylabel('sigma (stress unit)')
        end
    
    end
    
else
    
    einit=eprev;

    Ds=0:abs(send-sinit)/100:abs(send-sinit);
    for i=1:length(Ds),
        Der_1(i)=abs(Ds(i))/E+2*(abs(Ds(i))/(2*Ks))^(1/ns);
    end
    if sinit > send,
        er_1=einit-Der_1;
    else
        er_1=einit+Der_1;
    end

    eend=er_1(length(er_1));

    if Plots==1,
        figure(4)
        hold on
        if sinit > send,
            plot(er_1,sinit-Ds,'r')
        else
            plot(er_1,sinit+Ds,'r')
        end
        plot(es_c,s_c,'k','linewidth',2)
        plot(-es_c,-s_c,'k','linewidth',2)
        grid on
        title('Hysteresis Loops History')
        xlabel('strain')
        ylabel('sigma (stress unit)')
    end
end

