function [N,Ea,Nt,Eat] = material_e3(Sut,E,sm,sf,ef,b,c,Plots)


% E      Elastic modulus
% Sut    Ultimate tensile strength
% sm     Mean applyed stress

%Manson-Coffin parameters
% sf      
% ef      
% b     
% c     

% Plots  plot E-N curve

%________________________________

N0=1/2;  	                            %Cycles	
Nlim=1.00000E+07/2;  	                %Cycles	
N=[N0:100:Nlim];
Ea=(sf-sm)/E*(2*N).^b+ef*(2*N).^c;
Eae=(sf-sm)/E*(2*N).^b;                       %Basquin relation
Eap=ef*(2*N).^c;
Nt=1/2*((sf-sm)/(E*ef))^(1/(c-b));           %Transition limit
Eat=(sf-sm)/E*(2*Nt)^b+ef*(2*Nt)^c;

if Plots==1,

figure
loglog(2*N,Ea,'k','linewidth',2)
hold on
title('Manson-Coffin curve')
loglog(2*N,Eae,'r')
loglog(2*N,Eap,'b')
loglog(2*Nt,Eat,'ok','linewidth',2)
xlabel('log(Reversal)')
ylabel('log(Strain Amplitude)')

end