close all
clear all
clc

%Prova Flessionale
d=20; %(mm)
t=70; %F
r=5; %(mm) Foro

Sut=1200;
Sy=0.8*Sut;
Csut=0.044;
Kso=0.9;
Nse=1e6;
Kse=0.504;
Cse=0.146;
Rel=95;
Kb=1/3;

ka=57.7*Sut^-0.718;
Cka=0.11;
kb=(d/7.63)^-0.1133;
Ckb=0;
kc=1;
Ckc=0;
kd=(0.975+0.432e-3*t-0.115e-5*t^2+0.104e-8*t^3-0.595e-12*t^4);
Ckd=0.11;
a=0.025*(2070/Sut)^1.8;
q=1/(1+a/r);
Kt=2.2;
Kf=1+q*(Kt-1);
ke=1/Kf;
Cke=0.11;

K=ka*kb*kc*kd*ke;;
Ck=sqrt(Cka^2+Ckb^2+Ckc^2+Ckd^2+Cke^2);

Plots=1;

[Wb,N,S] = material(Sut, Csut, Nse, Kse, Kso, K, Kb, Rel, Cse, Ck, Plots);

[Wb(2) 1/Wb(2)];

ka=1.58*Sut^-0.085;
Cka=0.13;
kb=(d/7.63)^-0.1133;
Ckb=0;
kc=1;
Ckc=0;
kd=(0.975+0.432e-3*t-0.115e-5*t^2+0.104e-8*t^3-0.595e-12*t^4);
Ckd=0.11;
a=0.025*(2070/Sut)^1.8;
ke=1;
Cke=0;

K=ka*kb*kc*kd*ke;;
Ck=sqrt(Cka^2+Ckb^2+Ckc^2+Ckd^2+Cke^2);

[Wb,N,S] = material(Sut, Csut, Nse, Kse, Kso, K, Kb, Rel, Cse, Ck, Plots);

%Verifica di resistenza a Cicli assegnati
Nf=1e5;
Sf=Wb(1)*Nf^Wb(2);

%Punto con cui entrare nel piano di Haigh
sm=600;
sa=100;

stress=[1 sm sa];
%ES=0; %Goodman (Sa / Se + Sm / Sut = 1) 
%ES=1; %Gerber (Sa / Se + (Sm / Sut)^2 = 1) 
%ES=2; %No Correction
ES=0;
[stress_eqv] = eqvspec(stress, Sut, ES);

Orizz1=[1 Nf];
Vert1=[Sf Sf];
Orizz2=[Nf Nf];
Vert2=[10 Sf];

figure(2)
hold on
loglog(Orizz1,Vert1,'c--')
loglog(Orizz2,Vert2,'c--')
loglog(Nf,Sf,'*b')		

% Curve sul piano di Haigh

x1=0:Sut/100:Sut;
x2=0:Sy/100:Sy;

figure
% Curva di Goodman
ygo=Sf*(1-x1/Sut);
Goodman=plot(x1,ygo,'b');
set(Goodman,'Linewidth',1)
axis ([0 1.1*Sut 0 1.1*Sy])

hold on

% Curva di Gerber
yge=Sf*(1-(x1.^2/Sut^2));
Gerber=plot(x1,yge,'r');
set(Goodman,'Linewidth',1)

% Curva di Sodeberg
yso=Sf*(1-x2/Sy);
Sodeberg=plot(x2,yso,'g');
set(Sodeberg,'Linewidth',1)

% Curva ASME
yasme=Sf*(1-(x2.^2/Sy^2)).^(1/2);
ASME=plot(x2,yasme,'m');
set(ASME,'Linewidth',1)

% Curva di Bagci
yba=Sf*(1-(x2.^4/Sy^4));
Bagci=plot(x2,yba,'c');
set(Bagci,'Linewidth',1)

% Curva di Langer
yla=Sy*(1-x2/Sy);
Langer=plot(x2,yla,'k--');
set(Langer,'Linewidth',1)

grid on
title('Piano di Haigh')
xlabel('Tensione media     MPa')
ylabel('Tensione alterna     MPa')
text(Sy,Sy,'Goodman (b)')
text(Sy,0.9*Sy,'Gerber (r)')
text(Sy,0.8*Sy,'Sodeberg (g)')
text(Sy,0.7*Sy,'ASME (m)')
text(Sy,0.6*Sy,'Bagci (c)')

% Punto di lavoro
% tensione alterna
siga=sa; %MPa
% tensione media
sigm=sm; %MPa
Orizz1=[0 sigm];
Vert1=[siga siga];
Orizz2=[sigm sigm];
Vert2=[0 siga];

figure(3)
hold on
plot(Orizz1,Vert1,'c--')
plot(Orizz2,Vert2,'c--')
plot(sigm,siga,'*k')

% Coefficienti di sicurezza con tensioni media ed alterna proporzionali
[A]=SCoeffProp(Sut,Sy,Sf,sigm,siga);

% Tensione media costante, tensione alterna variabile
[Am]=SCoeffSmCost(Sut,Sy,Sf,sigm,siga,Plots);

% Tensione alterna costante, tensione media variabile
[Aa]=SCoeffSaCost(Sut,Sy,Sf,sigm,siga,Plots);


[A Aa Am]

