close all
clear all
clc

%Prova Flessionale
d=20; %(mm)
t=70; %F
r=5; %(mm) Foro

HB=630;
Sut=3.45*HB;
Csut=0.044;
Kso=0.9;
Nse=1e6;
Kse=0.504;
Cse=0.146;
Rel=95;
Kb=0;

ka=57.7*Sut^-0.718;
Cka=0.11;
kb=(d/7.63)^-0.1133;
Ckb=0;
kc=1;
Ckc=0;
kd=(0.975+0.432e-3*t-0.115e-5*t^2+0.104e-8*t^3-0.595e-12*t^4);
Ckd=0.11;
a=0.025*(2070/Sut)^1.8;
q=1/(1+a/r);
Kt=2.2;
Kf=1+q*(Kt-1);
ke=1/Kf;
Cke=0.11;

K=ka*kb*kc*kd*ke;;
Ck=sqrt(Cka^2+Ckb^2+Ckc^2+Ckd^2+Cke^2);

Plots=1;

[Wb,N,S] = material(Sut, Csut, Nse, Kse, Kso, K, Kb, Rel, Cse, Ck, Plots);

[Wb(2) 1/Wb(2)];

ka=1.58*Sut^-0.085;
Cka=0.13;
kb=(d/7.63)^-0.1133;
Ckb=0;
kc=1;
Ckc=0;
kd=(0.975+0.432e-3*t-0.115e-5*t^2+0.104e-8*t^3-0.595e-12*t^4);
Ckd=0.11;
a=0.025*(2070/Sut)^1.8;
ke=1;
Cke=0;

K=ka*kb*kc*kd*ke;;
Ck=sqrt(Cka^2+Ckb^2+Ckc^2+Ckd^2+Cke^2);

[Wb,N,S] = material(Sut, Csut, Nse, Kse, Kso, K, Kb, Rel, Cse, Ck, Plots);

[Wb(2) 1/Wb(2)];

Nh=1e4;   % cycle number at which to evaluate gerber curve
Smw=100;  % mean stress value at which to evaluate wohler curve
Rf=-1;     % Rf ratio Smin/Smax at which to evaluate wohler curve > -1

[Wb,N,S,Sr,Sw,Sah,Sm] = wohler3D(Sut, Csut, Nse, Kse, Kso, K, Kb, Rel, Cse, Ck, 1e4 ,100, Rf);

sm=100;
sa=200;

stress=[1 sm sa];
%ES=0; %Goodman (Sa / Se + Sm / Sut = 1) 
%ES=1; %Gerber (Sa / Se + (Sm / Sut)^2 = 1) 
%ES=2; %No Correction
ES=0;
[stress_eqv] = eqvspec(stress, Sut, ES);
