function [A]=SCoeffSaCost(Sut,Sy,Sf,sigm,siga,Plots)


A1=sigm;
A=ones(5,1);

if Plots ==1
    figure
end

% Goodman
Sm=Sut*(1-siga/Sf);%solve('siga/Sf+x/Sut=1');
%Sm=subs(Sm);
xx=sigm:(Sm-sigm)/20:Sm;
for i=1:length(xx),
   nn1=xx(i);
   nnGO(i)=Sm/nn1;
end
if Plots ==1
    plot(xx,nnGO,'b')
end
A(1)=max(nnGO);
if Sm>A1,
   A1=Sm;
end


hold on


% Gerber
Sm=Sut*(1-siga/Sf)^(1/2);%solve('siga/Sf+x^2/Sut^2=1');
%Sm=max(subs(Sm));
xx=sigm:(Sm-sigm)/20:Sm;
for i=1:length(xx),
   nn2=xx(i);
   nnGE(i)=Sm/nn2;
end
if Plots ==1
    plot(xx,nnGE,'r')
end
A(2)=max(nnGE);
if Sm>A1,
   A1=Sm;
end


% Sodeberg
Sm=Sy*(1-siga/Sf);%solve('siga/Sf+x/Sy=1');
%Sm=subs(Sm);
xx=sigm:(Sm-sigm)/20:Sm;
for i=1:length(xx),
   nn3=xx(i);
   nnSO(i)=Sm/nn3;
end
if Plots ==1
    plot(xx,nnSO,'g')
end
A(3)=max(nnSO);
if Sm>A1,
   A1=Sm;
end


% ASME
Sm=Sy*(1-(siga/Sf)^2)^(1/2);%solve('(siga/Sf)^2+x^2/Sy^2=1');
%Sm=max(subs(Sm));
xx=sigm:(Sm-sigm)/20:Sm;
for i=1:length(xx),
   nn4=xx(i);
   nnASME(i)=Sm/nn4;
end
if Plots ==1
    plot(xx,nnASME,'m')
end
A(4)=max(nnASME);
if Sm>A1,
   A1=Sm;
end


% Bagci
Sm=Sy*(1-siga/Sf)^(1/4);
xx=sigm:(Sm-sigm)/20:Sm;
for i=1:length(xx),
   nn5=xx(i);
   nnBA(i)=Sm/nn5;
end
if Plots ==1
    plot(xx,nnBA,'c')
end
A(5)=max(nnBA);
if Sm>A1,
   A1=Sm;
end


if Plots ==1
    title('Coefficienti di sicurezza a tensione alterna costante')
    axis([sigm A1 1 max(A)])
    xlabel('Tensione media          MPa')
    ylabel('Coefficiente di sicurezza')
    text(sigm+0.8*(A1-sigm),1+0.9*(max(A)-1),'Goodman (b)')
    text(sigm+0.8*(A1-sigm),1+0.8*(max(A)-1),'Gerber (r)')
    text(sigm+0.8*(A1-sigm),1+0.7*(max(A)-1),'Sodeberg (g)')
    text(sigm+0.8*(A1-sigm),1+0.6*(max(A)-1),'ASME (m)')
    text(sigm+0.8*(A1-sigm),1+0.5*(max(A)-1),'Bagci (c)')
end

