function [A]=SCoeffSmCost(Sut,Sy,Sf,sigm,siga,Plots)


A1=siga;
A=ones(5,1);

if Plots ==1
    figure
end

% Goodman
Sa=solve('x/Sf+sigm/Sut=1');
Sa=subs(Sa);
yy=siga:(Sa-siga)/20:Sa;
for i=1:length(yy),
   nn1=yy(i);
   nnGO(i)=Sa/nn1;
end
if Plots ==1
    plot(yy,nnGO,'b')
end
A(1)=max(nnGO);
if Sa>A1,
   A1=Sa;
end


hold on


% Gerber
Sa=solve('x/Sf+sigm^2/Sut^2=1');
Sa=max(subs(Sa));
yy=siga:(Sa-siga)/20:Sa;
for i=1:length(yy),   
   nn2=yy(i);
   nnGE(i)=Sa/nn2;
end
if Plots ==1
    plot(yy,nnGE,'r')
end
A(2)=max(nnGE);
if Sa>A1,
   A1=Sa;
end


% Sodeberg
Sa=solve('x/Sf+sigm/Sy=1');
Sa=subs(Sa);
yy=siga:(Sa-siga)/20:Sa;
for i=1:length(yy),
   nn3=yy(i);
   nnSO(i)=Sa/nn3;
end
if Plots ==1
    plot(yy,nnSO,'g')
end
A(3)=max(nnSO);
if Sa>A1,
   A1=Sa;
end


% ASME
Sa=solve('x^2/Sf^2+(sigm/Sy)^2=1');
Sa=max(subs(Sa));
yy=siga:(Sa-siga)/20:Sa;
for i=1:length(yy),
   nn4=yy(i);
   nnASME(i)=Sa/nn4;
end
if Plots ==1
    plot(yy,nnASME,'m')
end
A(4)=max(nnASME);
if Sa>A1,
   A1=Sa;
end


% Bagci
Sa=Sf*(1-(sigm/Sy)^4);
yy=siga:(Sa-siga)/20:Sa;
for i=1:length(yy),
   nn5=yy(i);
   nnBA(i)=Sa/nn5;
end
if Plots ==1
    plot(yy,nnBA,'c')
end
A(5)=max(nnBA);
if Sa>A1,
   A1=Sa;
end

if Plots ==1
    title('Coefficienti di sicurezza a tensione media costante')
    axis([siga A1 1 max(A)])
    xlabel('Tensione alterna          MPa')
    ylabel('Coefficiente di sicurezza')
    text(siga+0.8*(A1-siga),1+0.9*(max(A)-1),'Goodman (b)')
    text(siga+0.8*(A1-siga),1+0.8*(max(A)-1),'Gerber (r)')
    text(siga+0.8*(A1-siga),1+0.7*(max(A)-1),'Sodeberg (g)')
    text(siga+0.8*(A1-siga),1+0.6*(max(A)-1),'ASME (m)')
    text(siga+0.8*(A1-siga),1+0.5*(max(A)-1),'Bagci (c)')
end


