clc
close all 
clear all

%Prova Flessionale
d=20; %(mm)
t=70; %F
r=5; %(mm) Foro

HB=630;
Sut=3.45*HB;
Csut=0.044;
Kso=0.9;
Nse=1e6;
Kse=0.504;
Cse=0.146;
Rel=95;
Kb=0;

ka=57.7*Sut^-0.718;
Cka=0.11;
kb=(d/7.63)^-0.1133;
Ckb=0;
kc=1;
Ckc=0;
kd=(0.975+0.432e-3*t-0.115e-5*t^2+0.104e-8*t^3-0.595e-12*t^4);
Ckd=0.11;

a=0.025*(2070/Sut)^1.8;
q=1/(1+a/r);
qs=0.8*q;
Kt=1.3;
Kf=1+q*(Kt-1);
Kts=0.8*Kt;
Kfs=1+qs*(Kts-1);
ke=1/Kf;
Cke=0.11;

%_______________________
%
%_______________________
%
%Approccio A-F n.1

K=ka*kb*kc*kd;                      % Curva per componente non intagliato
Ck=sqrt(Cka^2+Ckb^2+Ckc^2+Ckd^2);   % Curva per componente non intagliato

Plots=1;

[Wb,N,S] = material(Sut, Csut, Nse, Kse, Kso, K, Kb, Rel, Cse, Ck, Plots);
hold on

%_______________________
%
%Auxiliary stress tensor history
%
ncycle=[450 130 400 200 10 50]';
Sxa=[150 100 60 100 200 250]';
Sxm=[100 50 10 40 150 175]';
Sya=[0 0 0 0 0 0]';
Sym=[0 0 0 0 0 0]';
Sxya=[75 10 100 20 40 100]';
Sxym=[50 20 80 10 30 70]';
%_______________________

Sxav=Kf*Sxa;
Syav=Kf*Sya;
Sxyav=Kfs*Sxya;

Sida=sqrt(Sxav.^2+Syav.^2+3*Sxyav.^2)
Sidm=sqrt(Sxm.^2+Sym.^2+3*Sxym.^2)

spettro=[ncycle Sidm Sida];

%ES=0; %Goodman (Sa / Se + Sm / Sut = 1) 
%ES=1; %Gerber (Sa / Se + (Sm / Sut)^2 = 1) 
%ES=2; %No Correction
ES=0;
[speceqv] = eqvspec(spettro, Sut, ES)

Miner_D=1;
[Dcum] = damage(speceqv, Miner_D, S, Wb, 0)

[Wb_m, Dcum] = manson(speceqv, Miner_D, Wb, N, S)
Smans=S(1:3);
Smans(3)=Wb_m(1)*N(3).^Wb_m(2);
figure(1)
p=loglog(N(2:3,1),Smans(2:3,1),'k');
set(p,'Linewidth',2);
p=loglog(N(1:2,1),Smans(1:2,1),'k--');
set(p,'Linewidth',1);
