function [spettro]=PVcount(signal,plotid)

picchi=zeros(2,length(signal));
valli=picchi;
pp=0;
vv=0;

segnale=signal(:,2);
tempo=signal(:,1);

segnalemedio=mean(segnale);

%primo ed ultimo punto dello spettro
if segnale(1)>segnalemedio,
   if segnale(1)>segnale(2),
      pp=pp+1;
      picchi(1,pp)=segnale(1);
      picchi(2,pp)=tempo(1);
   end
end
if segnale(1)<segnalemedio,
   if segnale(1)<segnale(2),
      vv=vv+1;
      valli(1,vv)=segnale(1);
      valli(2,vv)=tempo(1);
   end
end

%tutti i punti restanti dello spettro
for z=2:length(segnale)-1,
if segnale(z)>=segnalemedio,
   if segnale(z)>segnale(z-1),
      if segnale(z)>segnale(z+1),
         pp=pp+1;
         picchi(1,pp)=segnale(z);
         picchi(2,pp)=tempo(z);
      end
   end
else %segnale(z)<segnalemedio,
   if segnale(z)<segnale(z-1),
      if segnale(z)<segnale(z+1),
         vv=vv+1;
         valli(1,vv)=segnale(z);
         valli(2,vv)=tempo(z);
      end
   end
end
end

if segnale(length(segnale))>segnalemedio,
   if segnale(length(segnale))>segnale(length(segnale)-1),
      pp=pp+1;
      picchi(1,length(segnale))=segnale(length(segnale));
      picchi(2,length(segnale))=tempo(length(segnale));
   end
end
if segnale(length(segnale))<segnalemedio,
   if segnale(length(segnale))<segnale(length(segnale)-1),
      vv=vv+1;
      valli(1,length(segnale))=segnale(length(segnale));
      valli(2,length(segnale))=tempo(length(segnale));
   end
end

if plotid == 1
    figure
    plot(tempo,segnale);
    hold on
    grid on
    plot([min(tempo) max(tempo)],[segnalemedio segnalemedio],'k--','linewidth',2);
    xlabel('Tempo di acquisizione')
    ylabel('Segnale   MPa')
    for z=1:pp,
        plot(picchi(2,z),picchi(1,z),'or');
    end
    for z=1:vv,
          plot(valli(2,z),valli(1,z),'sr');
    end
    axis([min(tempo) max(tempo) min(segnale) max(segnale)])
end

pipicchi=zeros(1,pp);
vavalli=zeros(1,vv);

for u=1:pp,
   pipicchi(u)=picchi(1,u);
end
for u=1:vv,
   vavalli(u)=valli(1,u);
end

pipicchi=sort(pipicchi);
vavalli=sort(vavalli);

appoggio=zeros(pp,pp);		%matrice di appoggio per il ribaltamento del vettore pipicchi
for app=1:pp,
   appoggio(app,pp+1-app)=1;
end

pipicchi=pipicchi*appoggio;

% Ricostruzione dei cicli danneggianti secondo il PEAK VALLEY COUNTING

fine=min(pp,vv);

spettro=zeros(fine,3);		%1  cicli      2 media       3 alterna

for ics=1:fine,
   spettro(ics,1)=1;
   spettro(ics,2)=segnalemedio;
   spettro(ics,3)=(pipicchi(ics)-vavalli(ics))/2;
end

   