function [Wb_m, Dcum] = manson(speceqv, Miner_D, Wb, N, S)

%i.e.    [Wb_m, Dcum] = manson(speceqv, Miner_D, Wb, N, S)

%speceqv Equivalent alternating spectrum
%Miner_D Miner Damage limit
%S       Wohler parameter
%N       Wohler parameter
%Wb      Wohler parameter

[nr,nc]=size(speceqv);

a=Wb(1);
b=Wb(2);
sigl=S(3);
sige=speceqv;
for i=1:nr,   
  if sige(i,2) >= sigl,
      Ni=(sige(i,2)/a)^(1/b);    
      ni=sige(i,1);
      D(i)=ni/Ni;
      DN=Ni-ni;
      b=((log(sige(i,2)/S(2)))/(log(DN/N(2))));
      loga=log(((S(2))^2)/sige(i,2))-b*(log((10^6)/DN));
      a=exp(loga);
      sigl=a*N(3)^b;
  else
      D(i)=0;
  end
end

Wb_m=[a b];
Dcum=sum(D);
