function [x, y] = plotta_pdf(spec_eqv,divi,R,color,plotID)

% La funzione ricostruisce uno spettro equivalente ricampionandolo 
% in base alle divisioni definite dall'utente
%
% spec_eqv:  spettro equivalente; 
% divi:      divisioni del range di tensione
% R:         Grado di interpolazione (valore consigliato > 3)

[spec_ord,I]=sort(spec_eqv(:,2));
aa=min(spec_ord);
bb=max(spec_ord);
delta_sig=(bb-aa)/divi;
spec_eqv(:,1)=spec_eqv(I,1);
spec_eqv(:,2)=spec_ord;

spe_ric=(aa:delta_sig:bb);
spe_ric=spe_ric';
vvv=zeros(length(spe_ric),1);
spe_ric=[vvv spe_ric];

for i=1:length(vvv)
    cont=0;
    [w,y]=size(spec_eqv);
    for j=1:w
      if spec_eqv(j,2)<=spe_ric(i,2)
         spe_ric(i,1)=spe_ric(i,1)+spec_eqv(j,1);
         cont=cont+1;
      end 
   end
   [w,y]=size(spec_eqv);
   spec_eqv=spec_eqv(cont+1:w,:);
end

for i=1:length(vvv)
    somma1(i,1)=sum(spe_ric(i:length(vvv),1));
end
spe_sum=[somma1 spe_ric(:,2)];
    
somma=sum(spe_ric(:,1));
x=spe_ric(:,2);
y=spe_ric(:,1)/(somma*delta_sig);

if plotID==1
    figure(200)
    xx=interp(x,R);
    yy=interp(y,R);
    h11=plot(xx,yy,color,'linewidth',2);
    hold on
    grid on
    zoom on
    ylabel('PDF')
    xlabel('Stress Amplitude(Units)')
else
end

