function [muhat,sigmahat] = stat(input,camp,name,flag)

% i.e.   [muhat,sigmahat] = stat(input,camp,name,flag)

%input         input data
%camp          input data sampling
%flag          if flag=1 plot Gaussian distributionn

fitpdf=input;
Duration=camp;
Popolation=length(fitpdf);

mu=mean(fitpdf);
dev=std(fitpdf);
Csper=dev/mu;

%__________________________________________________

%pdf sperimentale
sper_pdf=(hist(fitpdf,Duration));
sper_pdf=sper_pdf./Popolation./mean(diff(Duration));
%__________________________________________________

%__________________________________________________

%cumulativa sperimantale
for i=1:length(sper_pdf)
somma(i)=sum(sper_pdf(1:i))*mean(diff(Duration));
end
ysper=somma;
%__________________________________________________


[muhat1,varhat1] = normstat(mu,dev);
[muhat,sigmahat,muci,sigmaci] = normfit(fitpdf);
npdf=normpdf(Duration,muhat,sigmahat);
ncdf=normcdf(Duration,muhat,sigmahat);
%npdf=normpdf(Duration,muhat1,sqrt(varhat1));
%ncdf=normcdf(Duration,muhat1,sqrt(varhat1));

NDuration=[min(Duration):(max(Duration)-min(Duration))/(length(Duration)*10):max(Duration)]';
Npdf=normpdf(NDuration,muhat,sigmahat);
Ncdf=normcdf(NDuration,muhat,sigmahat);

figure
hist(fitpdf,Duration)
grid on
axis([min(camp) max(camp) 0 max(hist(fitpdf,Duration))])
xlabel(name)
ylabel('samples')
name2=' histogram';
title([name name2])

if flag==1,

figure
normplot(fitpdf)
title(name)
grid on

%figure
%hold on
%histfit(fitpdf,length(Duration))
%plot(Duration,sper_pdf*Popolation*mean(diff(Duration)),'g','linewidth',2)
%grid on
%xlabel('x Data')
%ylabel('Data Histogram')
%title('Histogram')

figure
hold on
plot(Duration,sper_pdf,'g','linewidth',1)
%plot(Duration,npdf,'r','linewidth',1)
plot(NDuration,Npdf,'r','linewidth',2)
grid on
xlabel('x Data')
ylabel('f(x) Probability density')
name2='PDF and Normal Distribution for ';
title([name2 name])

figure
plot(Duration,ysper,'g','linewidth',1)
hold on
cdfplot(fitpdf)
%plot(Duration,ncdf,'r','linewidth',1)
plot(NDuration,Ncdf,'r','linewidth',2)
grid on
xlabel('x Data')
ylabel('F(x) Cumulative distribution function')
name2='CDF and Normal Cumulative for ';
title([name2 name])

linf=-0.5*dev+mu;
lsup=+0.5*dev+mu;
SPEC=[linf lsup];
normspec(SPEC,muhat,sigmahat)
grid on
name2='f(x) Probability density for ';
name3=' [-0.5 dev : +0.5 dev]'; 
ylabel([name2 name name3])

else
end

