% Comparison between Morrow and Coffin - Manson
% AE-97-11-18

clear all
% Material data SAE1045-steel
sf=1227e6;
ef=1;
e=200e9;
b=-0.095;
c=-0.66;

suts=724e6;
psi=0.65;

nf=[100:100:1000000];

% Strain - fatigue life relation according to Morrow
eam=sf./e.*(2.*nf).^b+ef.*(2.*nf).^c;

% Coffin Manson 
% Ductility
d=log(1/(1-psi))
eac=1.75.*suts./e.*nf.^(-0.12)+0.5.*d.^0.6.*nf.^(-0.6);

loglog(nf,eam,'--',nf,eac)
grid
title('Comparison between Morrow and Coffin-Manson')
xlabel('Fatigue life')
ylabel('Strain amplitude')
legend('Morrow','Coffin-Manson')