% The Neuber hyperbola
% AE-97-11-18

clear all
% Material data SAE1045-steel
sf=1227e6;
ef=1;
e=200e9;
b=-0.095;
c=-0.66;

suts=724e6;
psi=0.65;

kprim=1344e6;
nprim=0.18;

% Loads and stress concentration
sinf=400e6;
kf=3;

% Stress range
sa=[200e6:5e6:700e6];

% Neuber hyperbola
ean=kf.^2*sinf.^2./e./sa;


% Constitutive relation
ea=sa./e+(sa./kprim).^(1./nprim);

plot(ean,sa,'--',ea,sa)
grid
title('Using the Neuber hyperbola')
xlabel('Strain amplitude')
ylabel('Stress amplitude')
legend('Neuber hyperbola','Constitutive relation')